SYSTEMD-NSPAWN(1)

NAME
systemd-nspawn - Spawn a namespace container for debugging, testing and building

SYNOPSIS

systemd-nspawn [OPTIONS...] [COMMAND [ARGS...]]

systemd-nspawn -b [OPTIONS...] [ARGS...]

DESCRIPTION

systemd-nspawn may be used to run a command or OS in a light-weight namespace container. In many ways it is similar to chroot(1), but more powerful since it fully virtualizes the file system hierarchy, as well as the process tree, the various IPC subsystems and the host and domain name.

systemd-nspawn limits access to various kernel interfaces in the container to read-only, such as /sys, /proc/sys or /sys/fs/selinux. Network interfaces and the system clock may not be changed from within the container. Device nodes may not be created. The host system cannot be rebooted and kernel modules may not be loaded from within the container.

Note that even though these security precautions are taken systemd-nspawn is not suitable for secure container setups. Many of the security features may be circumvented and are hence primarily useful to avoid accidental changes to the host system from the container. The intended use of this program is debugging and testing as well as building of packages, distributions and software involved with boot and systems management.

In contrast to chroot(1) systemd-nspawn may be used to boot full Linux-based operating systems in a container.

Use a tool like yum(8), debootstrap(8), or pacman(8) to set up an OS directory tree suitable as file system hierarchy for systemd-nspawn containers.

Note that systemd-nspawn will mount file systems private to the container to /dev, /run and similar. These will not be visible outside of the container, and their contents will be lost when the container exits.

Note that running two systemd-nspawn containers from the same directory tree will not make processes in them see each other. The PID namespace separation of the two containers is complete and the containers will share very few runtime objects except for the underlying file system. It is however possible to enter an existing container, see Example 4 below.

systemd-nspawn implements the Container Interface[1] specification.

As a safety check systemd-nspawn will verify the existence of /etc/os-release in the container tree before starting the container (see os-release(5)). It might be necessary to add this file to the container tree manually if the OS of the container is too old to contain this file out-of-the-box.

INCOMPATIBILITY WITH AUDITING

Note that the kernel auditing subsystem is currently broken when used together with containers. We hence recommend turning it off entirely by booting with "audit=0" on the kernel command line, or by turning it off at kernel build time. If auditing is enabled in the kernel, operating systems booted in an nspawn container might refuse log-in attempts.

OPTIONS

If option -b is specified, the arguments are used as arguments for the init binary. Otherwise, COMMAND specifies the program to launch in the container, and the remaining arguments are used as arguments for this program. If -b is not used and no arguments are specifed, a shell is launched in the container.

The following options are understood:

-h, --help
    Prints a short help text and exits.

--version
    Prints a version string and exits.

-D, --directory=
    Directory to use as file system root for the namespace container. If omitted, the current directory will be used.

-b, --boot
    Automatically search for an init binary and invoke it instead of a shell or a user supplied program. If this option is used, arguments specified on the command line are used as arguments for the init binary.

-u, --user=
    Run the command under specified user, create home directory and cd into it. As rest of systemd-nspawn, this is not the security feature and limits against accidental changes only.

-M, --machine=
    Sets the machine name for this container. This name may be used to identify this container on the host, and is used to initialize the container's hostname (which the container can choose to override, however). If not specified, the last component of the root directory of the container is used.

--slice=
    Make the container part of the specified slice, instead of the machine.slice.

--uuid=
    Set the specified UUID for the container. The init system will initialize /etc/machine-id from this if this file is not set yet.

--private-network
    Turn off networking in the container. This makes all network interfaces unavailable in the container, with the exception of the loopback device.

--read-only
    Mount the root file system read-only for the container.

--capability=
    List one or more additional capabilities to grant the container. Takes a comma-separated list of capability names, see capabilities(7) for more information. Note that the following capabilities will be granted in any way: CAP_CHOWN, CAP_DAC_OVERRIDE, CAP_DAC_READ_SEARCH, CAP_FOWNER, CAP_FSETID, CAP_IPC_OWNER, CAP_KILL, CAP_LEASE, CAP_LINUX_IMMUTABLE, CAP_NET_BIND_SERVICE, CAP_NET_BROADCAST, CAP_NET_RAW, CAP_SETGID, CAP_SETFCAP, CAP_SETPCAP, CAP_SETUID, CAP_SYS_ADMIN, CAP_SYS_CHROOT, CAP_SYS_NICE, CAP_SYS_PTRACE, CAP_SYS_TTY_CONFIG, CAP_SYS_RESOURCE, CAP_SYS_BOOT, CAP_AUDIT_WRITE, CAP_AUDIT_CONTROL.

--link-journal=
    Control whether the container's journal shall be made visible to the host system. If enabled, allows viewing the container's journal files from the host (but not vice versa). Takes one of "no", "host", "guest", "auto". If "no", the journal is not linked. If "host", the journal files are stored on the host file system (beneath /var/log/journal/machine-id) and the subdirectory is bind-mounted into the container at the same location. If "guest", the journal files are stored on the guest file system (beneath /var/log/journal/machine-id) and the subdirectory is symlinked into the host at the same location. If "auto" (the default), and the right subdirectory of /var/log/journal exists, it will be bind mounted into the container. If the subdirectory does not exist, no linking is performed. Effectively, booting a container once with "guest" or "host" will link the journal persistently if further on the default of "auto" is used.

-j
    Equivalent to --link-journal=guest.

--bind=, --bind-ro=
    Bind mount a file or directory from the host into the container. Either takes a path argument -- in which case the specified path will be mounted from the host to the same path in the container --, or a colon-separated pair of paths -- in which case the first specified path is the source in the host, and the second path is the destination in the container. The --bind-ro= option creates read-only bind mount.

EXAMPLE 1

    # yum -y --releasever=19 --nogpg --installroot=/srv/mycontainer --disablerepo='*' --enablerepo=fedora install systemd passwd yum fedora-release vim-minimal
    # systemd-nspawn -bD /srv/mycontainer

This installs a minimal Fedora distribution into the directory /srv/mycontainer/ and then boots an OS in a namespace container in it.

EXAMPLE 2

    # debootstrap --arch=amd64 unstable ~/debian-tree/
    # systemd-nspawn -D ~/debian-tree/

This installs a minimal Debian unstable distribution into the directory ~/debian-tree/ and then spawns a shell in a namespace container in it.

EXAMPLE 3

    # pacstrap -c -d ~/arch-tree/ base
    # systemd-nspawn -bD ~/arch-tree/

This installs a mimimal Arch Linux distribution into the directory ~/arch-tree/ and then boots an OS in a namespace container in it.

EXAMPLE 4

To enter the container, PID of one of the processes sharing the new namespaces must be used. systemd-nspawn prints the PID (as viewed from the outside) of the launched process, and it can be used to enter the container.

    # nsenter -m -u -i -n -p -t $PID

nsenter(1) is part of util-linux[2]. Kernel support for entering namespaces was added in Linux 3.8.

EXIT STATUS

The exit code of the program executed in the container is returned.

SEE ALSO

systemd(1), chroot(1), unshare(1), yum(8), debootstrap(8), pacman(8), systemd.slice(5)

NOTES

1.  Container Interface
    http://www.freedesktop.org/wiki/Software/systemd/ContainerInterface

2.  util-linux
    https://github.com/karelzak/util-linux